# Copyright 2008, 2009 Canonical Ltd.  All rights reserved.

try:
    from launchpadlib.launchpad import (
        Launchpad, EDGE_SERVICE_ROOT, STAGING_SERVICE_ROOT)
except ImportError:
    print "Can't find launchpadlib, is your PYTHONPATH correct?\n"
    raise


systems=dict(staging=STAGING_SERVICE_ROOT,
             edge=EDGE_SERVICE_ROOT,
             beta=EDGE_SERVICE_ROOT,
             dogfood='https://api.dogfood.launchpad.net/1.0/',
             production='https://api.launchpad.net/1.0/',
             prod='https://api.launchpad.net/1.0/',
             )


def lpfactory(sysname, consumer_key):
    """Get a launchpad API instance for `sysname`."""
    try:
        sysname = sysname.lower()
        service_root = systems[sysname]
        return Launchpad.login_with(consumer_key, service_root=service_root)
    except KeyError:
        print "System '%s' not supported." % sysname
        print "Use one of: ", systems.keys()
        return None
